
// variables and routines for the blinking cursor functionality

#constant BLx, BLy, BLfontHeight, BLfontWidth, BLmaxCount, BLbotOffset, BLcolor1, BLcolor2, BLcurCountAdd, BLenable
var blinkProperties[BLenable + 1];

blinkProperties[BLenable] := TRUE;  // enable blinking by default

func setBlinkProperty(var property, var value)
    if(property < BLx || property > BLenable)
        return;
    endif
    blinkProperties[property] := value;
endfunc


func enableBlink()
    setBlinkProperty(BLenable, TRUE);
endfunc

func disableBlink()
    removeCursor();
    setBlinkProperty(BLenable, FALSE);
endfunc

func blinkCursor(var flag)
    if(!blinkProperties[BLenable])   return;
    var x1, x2, y;
    y := blinkProperties[BLy] + blinkProperties[BLfontHeight] + blinkProperties[BLbotOffset];
    x1 := blinkProperties[BLx] + (*blinkProperties[BLcurCountAdd])*blinkProperties[BLfontWidth];
    x2 := x1 + blinkProperties[BLfontWidth];
    if(flag)
        gfx_Line(x1, y, x2, y, blinkProperties[BLcolor2]);
    else
        gfx_Line(x1, y, x2, y, blinkProperties[BLcolor1]);
    endif
endfunc

func removeCursor()
    blinkCursor(FALSE);
endfunc

func removeAllCursors()
    var x1, x2, y;
    y := blinkProperties[BLy] + blinkProperties[BLfontHeight] + blinkProperties[BLbotOffset];
    x1 := blinkProperties[BLx];
    x2 := x1  + blinkProperties[BLmaxCount]*blinkProperties[BLfontWidth];
    gfx_Line(x1, y, x2, y, blinkProperties[BLcolor1]);
endfunc
